// C Source File
// Created 27/06/2003; 21:41:40

#include "const.h"
extern void* Vscreen1;
extern void Copy_scr(void* source asm("%a1"), void* destination asm("%a0"));

/* Voici une version modifie de la routine FastDrawLine de Extgraph qui la rend clippe et en niveaux de gris */

/*---------------------------------------------------------------------------*/
/* speedy pixel access routines                                              */
/*---------------------------------------------------------------------------*/
#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))

#define SETPIX(a,m)   (*(a) |= (m)) // uses precalculated values now
#define CLRPIX(a,m)   (*(a) &= ~(m))
#define XORPIX(a,m)   (*(a) ^= (m))
#define PIXUP(a)      ((a)-=30)
#define PIXDOWN(a)    ((a)+=30)
#define PIXLEFT(a,m)   asm("rol.b  #1,%0;bcc.s  0f;subq.l #1,%1;0:"\
                          : "=d" (m), "=g" (a) : "0" (m), "1" (a))
#define PIXRIGHT(a,m)  asm("ror.b  #1,%0;bcc.s  0f;addq.l #1,%1;0:"\
                          : "=d" (m), "=g" (a) : "0" (m), "1" (a))

/*---------------------------------------------------------------------------*/
/* useful macros                                                             */
/*---------------------------------------------------------------------------*/
#define ABS(a)          (((a)<0) ? -(a): (a))
#define SPECIAL_SGN(a)  (((a)<0) ? 0 : 1)
#define ASM_EXCHANGE(val1,val2) asm volatile ("exg %0,%1" : "=d" (val1),"=d" (val2) : "0" (val1),"1" (val2) : "memory","cc")
#define OUT_OF_SCREEN(x,y) (x < 0 || x >= lcd_w || y < 0 || y >= lcd_h)



void pix_black(unsigned char* a, unsigned char m)
{
	SETPIX(a,m);
	SETPIX(a+3840,m);
}
void pix_dark(unsigned char* a, unsigned char m)
{
	SETPIX(a,m);
	CLRPIX(a+3840,m);
}
void pix_light(unsigned char* a, unsigned char m)
{
	CLRPIX(a,m);
	SETPIX(a+3840,m);
}
void pix_white(unsigned char* a, unsigned char m)
{
	CLRPIX(a,m);
	CLRPIX(a+3840,m);
}
void pix_xor(unsigned char* a, unsigned char m)
{
	XORPIX(a,m);
	XORPIX(a+3840,m);
}


void pix(short x, short y, short color)
	{
	const unsigned char masks[8]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

	unsigned char m;
	unsigned char* a;

	a = Vscreen1 + (y<<5) - (y<<1) + (x>>3); // Adresse du pixel  modifier
	m = masks[x & 0x7]; // Masque du pixel  modifier

  if (color == BLACK) pix_black(a,m);	// Adresse de la fonction avec laquelle modifier l'tat du pixel
	else if (color == D_GRAY) pix_dark(a,m);
	else if (color == L_GRAY) pix_light(a,m);
	else if (color == WHITE) pix_white(a,m);
	else if (color == XOR) pix_xor(a,m);
	else return;	// Problme sur la couleur
	}


void CGrayLineClip(short x1, short y1, short x2, short y2, short color)
{
short d,x,y,ax,ay,sx,sy,dx,dy,out1,out2;
void(*modif_pix)(unsigned char*,unsigned char); // Pointeur sur une fonction pix_

unsigned char *pixaddr;
unsigned char pixmask;

	// Dessiner la ligne si elle est au moins partiellement dans l'cran
	/*out1 = OUT_OF_SCREEN(x1, y1);
	out2 = OUT_OF_SCREEN(x2, y2);

	if (out1 && !out2)	// si le point 2 est dans l'cran et le point 1 hors de l'cran inverser les deux points
		{
		ASM_EXCHANGE(x1, x2);
		ASM_EXCHANGE(y1, y2);
		}
	if (out1 && out2) return; // si les deux points sont dehors ne rien tracer
*/
  dx = x2 - x1;
  ax = ABS(dx)<<1;
  sx = SPECIAL_SGN(dx);

  dy = y2 - y1;
  ay = ABS(dy)<<1;
  sy = SPECIAL_SGN(dy);

  x = x1;
  y = y1;

  pixaddr=PIXADDR(Vscreen1, x, y);
  pixmask=PIXMASK(x);

	if (color == BLACK) modif_pix = pix_black;	// Adresse de la fonction avec laquelle modifier l'tat du pixel
	else if (color == D_GRAY) modif_pix = pix_dark;
	else if (color == L_GRAY) modif_pix = pix_light;
	else if (color == WHITE) modif_pix = pix_white;
	else if (color == XOR) modif_pix = pix_xor;
	else return;	// Problme sur la couleur

    if (ax>ay) // x dominant
    	{
      d = ay - (ax>>1);
      do
       	{
        //if (x==-1 || x==lcd_w || y==-1 || y==lcd_h) return;
				modif_pix(pixaddr,pixmask);
				if (x==x2) return;
          if (d>=0)
          	{
            if(sy)	{ PIXDOWN(pixaddr); y++; }
            else    { PIXUP(pixaddr);   y--; }
            d -= ax;
            }
          if (sx) { PIXRIGHT(pixaddr, pixmask); x++; }
          else		{ PIXLEFT(pixaddr, pixmask);  x--; }
            d += ay;
        } while(1);
      }
    else // y dominant
     	{
      d = ax - (ay>>1);
      do
       	{
        //if (x==-1 || x==lcd_w || y==-1 || y==lcd_h) return;
        modif_pix(pixaddr,pixmask);
        if (y==y2) return;
        if (d>=0)
          {
          if (sx)	{	PIXRIGHT(pixaddr, pixmask);	x++; }
          else    { PIXLEFT(pixaddr, pixmask);  x--; }
          d -= ay;
          }
        if (sy) { PIXDOWN(pixaddr); y++; }
        else   	{ PIXUP(pixaddr); 	y--; }
        d += ax;
        } while(1);
      }
}


// Dessine un sprite de largeur multiple de 8 sur l'cran, cal en x sur la grille d'octets, sans clipping
void GridGraySprite(short x, short y, short hx, short hy, unsigned char* layer1, unsigned char* layer2, unsigned char* plane1, unsigned char* plane2)
{
	unsigned char *addr1, *addr2, *addr3, *addr4;
	short i;

	for (i=0, addr1 = plane1 + x + (y<<5) - (y<<1), addr2 = layer1, addr3 = plane2 + x + (y<<5) - (y<<1), addr4 = layer2;
			 i<hy;
			 i++, addr1+=30, addr2+=hx, addr3+=30, addr4+=hx)
		{
		memcpy(addr1,addr2,hx);
		memcpy(addr3,addr4,hx);
		}
}

// Dessine un sprite de largeur multiple de 8 sur l'cran, cal en x sur la grille d'octets, sans clipping
void GridGraySpriteXOR(short x, short y, short hx, short hy, unsigned char* layer1, unsigned char* layer2, unsigned char* plane1, unsigned char* plane2)
{
	unsigned char *addr1, *addr2, *addr3, *addr4;
	short i, j;

	for (i=0, addr1 = plane1 + x + (y<<5) - (y<<1), addr2 = layer1, addr3 = plane2 + x + (y<<5) - (y<<1), addr4 = layer2;
			 i<hy;
			 i++, addr1+=30, addr2+=hx, addr3+=30, addr4+=hx)
		{
		for (j=0; j<hx; j++)
			{
			*(addr1+j) ^= *(addr2+j);
			*(addr3+j) ^= *(addr4+j);
			}
		}
}


// Copie le contenu de l'cran virtuel vers le LCD
void DrawVirtual(void)
{
	Copy_scr(Vscreen1, GrayGetPlane(DARK_PLANE));
	Copy_scr(Vscreen2, GrayGetPlane(LIGHT_PLANE));
}




#define BOUCL(x) (x>=n ? x-n : x)
#define INFINITY_S 32767
extern void fill_span_white(short asm("%d0"), short asm("%d1"), UCHAR* asm("%a0"));
extern void fill_span_light(short asm("%d0"), short asm("%d1"), UCHAR* asm("%a0"));
extern void fill_span_dark (short asm("%d0"), short asm("%d1"), UCHAR* asm("%a0"));
extern void fill_span_black(short asm("%d0"), short asm("%d1"), UCHAR* asm("%a0"));

void n_poly_fill(ScrPoint* Pt, short n, short color)
{
	void (*fill_span)(short asm("%d0"), short asm("%d1"), UCHAR* asm("%a0"));

	switch (color)
		{
		case WHITE:
		fill_span = fill_span_white;
		break;
		case L_GRAY:
		fill_span = fill_span_light;
		break;
		case D_GRAY:
		fill_span = fill_span_dark;
		break;
		case BLACK:
		fill_span = fill_span_black;
		break;
		default:
		return;
		}

	short i, i0 = 0, j;
	short yMin = Pt[0].y;

	// Recherche du point suprieur (y le plus petit)
	for (i=1; i<n; i++) if (Pt[i].y < yMin)
		{
		yMin = Pt[i].y;
		i0 = i;
		}

	// Rorganisation des points, points suprieur le premier
	ScrPoint P[11];
	for (j=0; j<n; j++) P[j] = Pt[BOUCL((j+i0))];

	short s[11];
	P[n]=P[0];
	// Calcul des pentes de tous les cts
	for (i=0; i<n; i++)
		{
		short dy = P[i+1].y - P[i].y;
		if (dy) s[i] = ((P[i+1].x - P[i].x)<<7) / dy;
		else s[i] = INFINITY_S;
		}

	// Trac
	short y = P[0].y;
	UCHAR* addr = Vscreen1 + (y<<5) - (y<<1);
	short xi = P[0].x << 7;
	short xj = xi;

	i = 0; j = n-1;
	while(i<j)
		{
		if (s[i] == INFINITY_S) xi = P[++i].x << 7;
		else if (s[j] == INFINITY_S) xj = P[j--].x << 7;
		else
			{
			short y_stop = (P[i+1].y > P[j].y ? P[j].y : P[i+1].y);
			for(; y<y_stop; y++, xi += s[i], xj += s[j], addr += 30)
				if (y>=0 && y<lcd_h) fill_span(xi>>7, xj>>7, addr);
			if (y_stop == P[i+1].y) i++;
			else j--;
			}
		}

	// Dernire ligne
	if (y>=0 && y<lcd_h) fill_span(xi>>7, xj>>7, addr);
}
