// Constantes et sctructures


#define USE_TI89
#define USE_TI92PLUS
#define USE_V200
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files

//#define USE_LINK

// MACRO produit scalaire
#define SCAL(V1,V2) (V1.x * V2.x + V1.y * V2.y + V1.z * V2.z)
// MACROs Oprations sur les angles avec rebouclage 512 <-> 0
#define A_INC(ang,nb) {(ang) += (nb); (ang) &= 0x01ff;}
#define A_DEC(ang,nb) {(ang) -= (nb); (ang) &= 0x01ff;}


#define Vscreen2 (Vscreen1+LCD_SIZE)

#define Distorsion 80
#define VISION_LIMIT 38400 // Distance  partir de laquelle les onjects ne sont plus affichs (plan 'far' du frustrum clipping)
#define STARS_NB 50

// Positions des lments graphiques
#define RADAR_CTR_X (lcd_w-13)
#define RADAR_CTR_Y (lcd_h-13)

#define COMPT_X 8
#define COMPT_Y (lcd_h-8)

extern short lcd_w, lcd_h, lcd_b, lcd_focal, lcd_wd, lcd_bd, lcd_hd; // Variables pour remplacer LCD_WIDTH ...

enum colors {WHITE = 0, L_GRAY, D_GRAY, BLACK, XOR};
enum exit_status {NO_ERR, MEM_ERR, LINK_ERR, GAME_LINK_ERR};
enum sides {LEFT, RIGHT};

// structure pour un vertex (point 3D), ou vecteur
typedef struct
{
  short x;
  short y;
  short z;
} Vertex;

#define Vector Vertex

// structure pour un vertex  capacit tendue (long)
typedef struct
{
  long x;
  long y;
  long z;
} lgVertex;
#define lgVector lgVertex

// structure pour un point  l'cran (point 2D)
typedef struct
{
  short x;
  short y;
} ScrPoint;

// structure qui contient les trois angles d'un objet
typedef struct
{
	short x;
	short y;
	short z;
} Angle;

typedef struct
{
	int point1;
	int point2;
} Line;

/* Structure pour un poly jusqu'a 10 sommets (BigPoly) */
typedef struct
{
	short summitNb;
	short summits[10];
	short visibleSides;
	short color;
} BPoly;


/* Structure pour un plan */
typedef struct
{
  Vector normal;  // verteur normal au plan
  long dist;      // distance  l'origine
} Plane;


typedef struct
{
	short type; // Type de camra : 1re personne ou 3me personne
	Vertex pos;
	Angle ang;
	Vector offset;	// Distance  laquelle la camra est loigne du centre en mode 3me personne
} Camera;


// Coordonnes d'un solide, cad trois coordonnes de position et 3 coordonnes d'angles
// vitesse et damage et sq_radius servent uniquement pour les vaisseaux
typedef struct
{
	Vertex pos;
	Angle ang;
	short speed; // Vitesse actuelle des vaisseaux
	unsigned char damage; // Champ de bits tat des 8 secteurs du vaisseau
} SolidC;


typedef struct
	{
	Vertex* ptrVert;
	short vertNb;
	short* ptrPolys;
	short polyNb;

	short* ptrEnds;
	short* ptrCanons;

	const char* name;
	short nameShift;
	float bonus;
	} SHIP_INFO;


// Structure de missiles, une correspond  chaque vaisseau en jeu
// Le missiles qui a parcouru la plus grande distance est constamment celui  l'index 0 (celui qui  t tir le premier dans le temps)
#define MAX_MISS 20
#define MISS_SPEED 75
#define MISS_RANGE 25
typedef struct
	{
	short missNb;
	SolidC coord[MAX_MISS]; // Tableau de coordonnes des missiles
	Vector dir[MAX_MISS]; // Tableau de vecteurs directeurs des missiles
	short dist[MAX_MISS]; // Distance parcourue par les missiles
	short alt; // Alternance des tirs de missiles
	} MissSet;


// Communication en link (calc to calc)
#define COM_TRY 57
#define COM_OK 33
enum calcStates {UNKNOWN = 0, JOINED, HOSTING, SINGLE};

// Statut de mon vaisseau  envoyer en info  l'autre calc par le link
typedef struct
	{
	char missLaunched;
	char explStarted;
	char paused;
	} Status;


// Modes de contrle
enum {ARCADE = 0, SIMULATION};


// Structure explosion
typedef struct
	{
	short active;
	SolidC coord[6]; // Positions et angles
	Vector dir[6]; // Vecteur vitesse
	} Explosion;
#define EXPL_MAX 25
